Program Function_Analyzer;
{
  Copyright (C) 1998,1999 Idan Nof (GNU GPL)
  Read the attached files "README.TXT" and "GPL.TXT" for more details

  The 'Function Analyzer' - a program for analysis and sketch
  of various functions.

-----------------------------------------------------------------------------
}

{$I SYMBOLS.INC}

Uses Funcunit;

Var
  i    : Integer;

Begin { Main }
   Init;                           { Init - parameters & graphics }

   Repeat
      TF := 0;
      Repeat
         Inc(TF);

         {$IFDEF DEBUG}
         CheckF(Funcs[TF]);
         {$ENDIF      }

         InitFunc(Funcs[TF]);      { System : memory allocation          }
         ChooseType(Funcs[TF]);    { User   : choose function type       }
         Get(Funcs[TF]);           { User   : input function             }

         {$IFDEF DEBUG}
         CheckF(Funcs[TF]);
         {$ENDIF      }

      Until (AddAnotherFunc=False);

      For i:=1 to TF do
          Begin
             {$IFDEF DEBUG}
             CheckF(Funcs[TF]);
             {$ENDIF      }

             Analyze(Funcs[i]);     { Process : numerical analysis }

             {$IFDEF DEBUG}
             CheckF(Funcs[TF]);
             {$ENDIF      }

             WriteAnalyze(Funcs[i]);{ Output : analysis           }

             {$IFDEF DEBUG}
             CheckF(Funcs[TF]);
             {$ENDIF      }
          End;

      Sketch(Funcs);               { Output : sketch of function(s)      }
      DisposeOf(Funcs);            { System : memory disposal            }

   Until (DoYouWantAnother=False);

   Quit;                            { Quit - Restore original screen mode }
End. { Main }