{ Include file for user-defined symbols and compiler directives}

{- Compiler Directives ------------------------------------------------------}

{$G+}     { Use 80286 opcodes }
{$N+,E+}  { Use 80x87 or emulate coprocessor if required }

{$A+,B-,I-,O-,P-,T-,V+,X+}

{- User Defined Symbols ----------------------------------------------------}

{.DEFINE VERBOSE}
{.DEFINE DEBUG  }

{$IFDEF DEBUG} {Q+,R+,S+,D+,L+,Y+}
{$ELSE}        {Q-,R-,S-,D-}
{$ENDIF}

{- Meaning of symbols --------------------------------------------------------

 The VERBOSE symbol, when will be implemented properly, is supposed
 to give some info on the program's calculations.
 It can also be used along with the DEBUG symbol to provide more thorough
 debugging facilities.

------------------------------------------------------------------------------

 The DEBUG symbol, when will be implemented properly, is supposed to
 help the user check for common bugs that might appear after revisions,
 whether by internal compiler run-time checks such as Stack Overflow,
 Range Check & Overflow and by user-implemented checks to verify the
 integrity of the data structures and other symptoms.
 It also causes the compiler to include debugging information necessary
 to operate the integrated/standalone debugger.

-----------------------------------------------------------------------------
}
