Unit Vesa;

Interface
Function DetectVesa256: Integer; far;

implementation

Uses Graph;

const
  VESA256Modes: array[0..2] of Word =
    ($0103, $0105, $0107);

type
  VgaInfoBlock = record
    VESASignature: array[0..3] of Byte;
    VESAVersion: Word;
    OEMStringPtr: Pointer;
    Capabilities: array[0..3] of Byte;
    VideoModePtr: Pointer;
  end;

function GetHighestCap(Table: Pointer; Modes: Word; Size:
Integer): Integer;
  near; assembler;
asm
        XOR     AX,AX
        LES     DI, Table
@1:
        MOV     SI, Modes
        ADD     SI, Size
        ADD     SI, Size
        SUB     SI, 2
        MOV     BX, ES:[DI]
        CMP     BX, 0FFFFH
        JE      @4
        INC     DI
        INC     DI
        MOV     CX,Size
@2:
        CMP     BX,[SI]
        JZ      @3
        DEC     SI
        DEC     SI
        LOOP    @2
@3:
        CMP     AX,CX
        JA      @1
        MOV     AX,CX
        JMP     @1
@4:
        DEC     AX
end;

function DetectVesa256: Integer; assembler;
var
  VesaInfo: array[0..255] of Byte;
asm
        MOV     AX,SS
        MOV     ES,AX
        LEA     DI,VesaInfo
        MOV     AX,4F00H
        INT     10H
        CMP     AX,004FH
        MOV     AX,grError
        JNZ     @Exit
        CMP     ES:[DI].VgaInfoBlock.VESASignature.Word[0], 'EV'
        JNZ     @Exit
        CMP     ES:[DI].VgaInfoBlock.VESASignature.Word[2], 'AS'
        JNZ     @Exit
{!}
        LES     DI,ES:[DI].VgaInfoBlock.VideoModePtr
        PUSH    ES
        PUSH    DI
        MOV     AX, OFFSET Vesa256Modes
        PUSH    AX
        MOV     AX,3
        PUSH    AX
        CALL    GetHighestCap
{!}
        MOV     AX,3  {Default mode is 800x600x256}
@Exit:
end;

End.